(* Dans ce td, nous faisons des expriences de construction de drivation
  de smantique axiomatique. *)

Require Import syntax parser axiom String List ZArith.
Open Scope Z_scope.

Definition sum1 : instr :=
  Eval vm_compute in 
  match parse_i "x:=0; y:=0; while x < 10 do x := x+1; y:=y+x done"  with
    Some(i) => i
  | None => assign "a" (anum 1)
  end.

(* Ajouter le prdicat d'galit dans le langage d'assertion. *)

Definition eq_pred (l:list Z) : Prop :=
  match l with n1::n2::nil => n1 = n2 | _ => False end.

(* ajouter le prdicat de comparaison dans le langage d'assertion. *)
Definition le_pred (l:list Z) : Prop :=
  match l with n1::n2::nil => n1 <= n2 | _ => False end.

Definition m := ("eq", eq_pred)::("le", le_pred)::nil.

Definition parse_e' (s:string) :=
  match parse_e s with Some e => e | None => anum 0 end.

Notation "X ''/\'' Y" := (a_conj X Y) (at level 15, only parsing).
Notation "''~'' X" := (a_not X) (at level 14, only parsing).
Notation "X ''='' Y" :=
   (pred "eq" (parse_e' X::parse_e' Y::nil)) (at level 13, only parsing).
Notation "X ''<='' Y" :=
   (pred "le" (parse_e' X::parse_e' Y::nil)) (at level 13, only parsing).
Notation "X ''<'' Y" :=
   (a_b (blt (parse_e' X) (parse_e' Y))) (at level 13, only parsing).

Definition Q1 := Eval vm_compute in ("y" '=' "55").
Eval vm_compute in tokenize "x" Start "".
Eval lazy zeta beta iota delta [parse_expr] in parse_expr (T_id "x" :: nil) 1.
Eval lazy zeta beta iota delta [parse_right_expr] in
  parse_right_expr parse_expr nil 0 (avar "x").

Ltac parse_all :=
  match goal with
  | |- context[parse_e' ?x] =>
    let v := eval vm_compute in (parse_e' x) in
      change (parse_e' x) with v; parse_all
  | _ => idtac
  end.

Ltac expand_semantics :=
 lazy beta zeta iota delta [valid m i_a i_c f_p string_dec string_rec
  string_rect sumbool_rec sumbool_rect Ascii.ascii_dec Ascii.ascii_rec
  Ascii.ascii_rect Bool.bool_dec bool_rec bool_rect eq_rec_r
  eq_rec eq_rect sym_eq le_pred eq_pred lf' af'].

Ltac apply_ax_a :=
match goal with 
  |- ax_sem ?m _ (assign ?x ?e) ?P => apply (ax_a m P x e)
end.

Lemma assign_0 :
  ax_sem m a_true (assign "x" (anum 0)) ("x" '=' "0").
(* Faites cette preuve. *)
Admitted.

Lemma assign_1 :
  ax_sem m ("x" '=' "0") (assign "y" (anum 0)) ("x" '=' "0" '/\' "y" '=' "0").
(* faites aussi celle-ci. *)
Admitted.


Lemma res55 :  ax_sem m a_true sum1 Q1.
unfold Q1, sum1.
apply ax_s with (Q := "x" '=' "0").
apply assign_0.
apply ax_s with (Q := ("x" '=' "0" '/\' "y" '=' "0")).
apply assign_1.
apply ax_c with
  (P' := "x" '<=' "10" '/\' "y" '=' "x*(x+1)")
  (Q' := '~' "x" '<' "10" '/\' ("x" '<=' "10" '/\' "y" '=' "x*(x+1)")).
parse_all.
expand_semantics.
intros g [Hx Hy]; rewrite Hx; rewrite Hy; split; omega || ring.
apply ax_w.
(* completez cette preuve. *)



apply (ax_a m (pred "eq" (avar "x"::anum 0::nil)) "x" (anum 0)).

apply ax_c with
  (Q' := '~' "x" '<' "10" '/\' "x" '<=' "10" '/\' "2*y" '=' "x*x+1")
  (P' :=  a_true).
parse_all.
expand_semantics.
auto.
intros g; generalize (g "x") (g "y"); intros x y.

